-----------------------------------------------------------------------------------------------
-- Client Lua Script for BGBot
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- BGBot Module Definition
-----------------------------------------------------------------------------------------------
local BGBot = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function BGBot:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function BGBot:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- BGBot OnLoad
-----------------------------------------------------------------------------------------------
function BGBot:OnLoad()

	if Apollo.GetAddon("VikingContextMenuPlayer") ~= nil then
	    self.contextMenuPlayer = Apollo.GetAddon("VikingContextMenuPlayer")
	else
	    self.contextMenuPlayer = Apollo.GetAddon("ContextMenuPlayer")
	end
    local oldRedrawAll = self.contextMenuPlayer.RedrawAll

    self.contextMenuPlayer.RedrawAll = function(context)
        if self.contextMenuPlayer.wndMain ~= nil then
            local wndButtonList = self.contextMenuPlayer.wndMain:FindChild("ButtonList")
            if wndButtonList ~= nil then
                local wndNew = wndButtonList:FindChildByUserData(tObject)
                if not wndNew then
                    wndNew = Apollo.LoadForm(self.contextMenuPlayer.xmlDoc, "BtnRegular", wndButtonList, self.contextMenuPlayer)
                    wndNew:SetData("ReportBot")
                end
                wndNew:FindChild("BtnText"):SetText("Report Bot")
            end
        end
        oldRedrawAll(context)
    end

    local oldProcessContextClick = self.contextMenuPlayer.ProcessContextClick
    self.contextMenuPlayer.ProcessContextClick = function(context, eButtonType)
        if eButtonType == "ReportBot" then
            self:ReportBot(self.contextMenuPlayer.strTarget)
        else
            oldProcessContextClick (context, eButtonType)
        end
    end

end

-----------------------------------------------------------------------------------------------
-- BGBot Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/bgbot"
function BGBot:OnBGBotOn(cmd, args)
	if args == nil or args == "" or GroupLib.GetMemberCount() == 0 then return end
    for i=1,GroupLib.GetMemberCount() do
        if GroupLib.GetGroupMember(i) ~= nil and GroupLib.GetGroupMember(i) == args then
            self:ReportBot(args)
            return
        end
    end	
end

function BGBot:ReportBot(name)
	local report = "Bot report generated by BGBot Addon, created by Goldblum (Widow server)\n\n"
	report = report .. "Player being reported: " .. name .. "\n"
	report = report .. "Zone player was reported in: " .. self:CurrentZone() .. "\n"
	report = report .. "Server time of report (d/m/yyyy h:m:s am): " .. self:ServerTimeString() .. "\n\n"
	report = report .. "Thank you for your time"
	PlayerTicketDialog_Report(2, 6, report)
end

function BGBot:CurrentZone()
	local currentZone = GameLib.GetCurrentZoneMap()
	if currentZone == nil then
		return "Unknown"
	else
		return currentZone.strName
	end
end

function BGBot:ServerTimeString()
	local serverTime = GameLib.GetServerTime().nDay .. "/" .. GameLib.GetServerTime().nMonth .. "/" .. GameLib.GetServerTime().nYear .. " " .. GameLib.GetServerTime().strFormattedTime
	return serverTime
end

-----------------------------------------------------------------------------------------------
-- BGBot Instance
-----------------------------------------------------------------------------------------------
local BGBotInst = BGBot:new()
BGBotInst:Init()
